* concat.s - part of execd
*
* a1.l   ..first line of script (MALLOC'ed, zero terminated)
* a2.l..script name
* a3.l..script argument
* a4.l..environment pointer
*
* output: a5.l fil
*	  (256+8(a1).l p1)
* broken: a0,a2,a3,a5,d0,d1


* Include File -------------------------------- *

	.include doscall.mac


* Global Symbol ------------------------------- *

	.xref	exec2


* Text Section -------------------------------- *

	.cpu	68000

	.text
	.even

concat::
	move.l	a1,-(sp)
	addq.l	#1,a3		* A3 := beginning of script argument body

	lea	(2,a1),a0	* skip '#!'

skip_blank:
	move.b	(a0)+,d1
	beq	line_too_long
	cmpi.b	#13,d1		;CR
	beq	no_scriptname
	cmpi.b	#10,d1		;LF
	beq	no_scriptname
	cmpi.b	#' ',d1
	beq	skip_blank
	cmpi.b	#9,d1		;TAB
	beq	skip_blank

	lea	(-1,a0),a5	* make fil

split_1line:
	move.b	(a0)+,d1
	beq	line_too_long
	cmpi.b	#13,d1		;CR
	beq	split_args
	cmpi.b	#10,d1		;LF
	bne	split_1line

split_args:
	clr.b	-(a0)

	movem.l	a0-a6,-(sp)
	pea	(a4)
	pea	(256+8,a1)
	pea	(a5)
	move	#2,-(sp)	* glue
	movea.l	sp,a6
	bsr	exec2		* make p1
	lea	(14,sp),sp
	movem.l	(sp)+,a0-a6

	moveq	#0,d0
	move.b	(256+8,a1),d0
	move.l	d0,d1		*  len of p1 (initial args for interpreter)
	beq	count_namelen	*  (separator is not needed)

	addq.l	#1,d0		*  + separator
count_namelen:			*  + script name and argbuf terminator
	movea.l	a2,a0

namelen_loop:
	addq.l	#1,d0
	tst.b	(a0)+
	bne	namelen_loop
	tst.b	(a3)
	beq	count_arg0length
	movea.l	a3,a0

count_arglength:		* + script args
	addq.l	#1,d0
	tst.b	(a0)+
	bne	count_arglength

count_arg0length:
	movea.l	a5,a0

count_arg0length_loop:		*  + arg0
	addq.l	#1,d0
	tst.b	(a0)+
	bne	count_arg0length_loop

	addi.l	#256+8+1,d0	*  + fil + hupair mark + p1 length byte
	move.l	d0,-(sp)
	move.l	a1,-(sp)
	DOS	_SETBLOCK
	addq.l	#8,sp
	tst.l	d0
	bmi	error

	lea	(256+1+8,a1),a0
	adda.l	d1,a0
	tst.l	d1
	beq	copy_name
	move.b	#' ',(a0)+

copy_name:
	move.b	(a2)+,(a0)+
	bne	copy_name

	subq.l	#1,a0
	tst.b	(a3)
	beq	copy_arg

	move.b	#' ',(a0)+

copy_arg:
	move.b	(a3)+,(a0)+
	bne	copy_arg

	movea.l	a0,a3
	movea.l	a5,a2

copy_arg0:
	move.b	(a2)+,(a3)+
	bne	copy_arg0

set_arglength:
	lea	(256+8,a1),a1
	suba.l	a1,a0
	move.l	a0,d0
	subq.l	#2,d0
	cmpi.l	#256,d0
	blt	set_arglen
	st	d0		;move.b	#255,d0
set_arglen:
	move.b	d0,(a1)

	moveq	#0,d0
error:
	movea.l	(sp)+,a1
	rts

no_scriptname:
line_too_long:
	moveq	#-11,d0
	bra	error

	.end

* End of File --------------------------------- *
